namespace ADO.HandlingRowErrors
{
	using System;
	using System.Data;
	using System.Data.SqlClient;

	public class handleerrors
	{
		public static void Main()
		{
			handleerrors myhandleerrors = new handleerrors();
			myhandleerrors.Run();
		}

		public void Run()
		{
			// Create a new Connection and SqlDataAdapter
			SqlConnection myConnection = new SqlConnection(
				"server=xeon;uid=sa;pwd=manager;database=northwind");
			SqlDataAdapter mySqlDataAdapter = new SqlDataAdapter(
				"select * from customers", myConnection);

			// Create the new instance of the DataSet
			DataSet myDataSet = new DataSet();

			try
			{
				// Load the customer table from the database
				// into a table called Customers in the dataset
				mySqlDataAdapter.Fill(myDataSet,"Customers");

				// Create a new dataview instance on the Customers
				// table that was just created
				DataView myDataView = new DataView(myDataSet.Tables["Customers"]);

				// Sort the view based on the FirstName column
				myDataView.Sort = "CustomerID";

				// Manually add Errors ...
				myDataSet.Tables["Customers"].Rows[0].RowError =
					"Manually added an Error in Row 1";
				myDataSet.Tables["Customers"].Rows[1].RowError =
					"Manually added an Error in Row 2";

				// ... and check the DataTable for these inserted Errors
				if ( myDataSet.Tables["Customers"].HasErrors )
				{
					// If we have Errors, get them ...
					DataRow[] ErrDataRows = myDataSet.Tables["Customers"].GetErrors();
					Console.WriteLine("DataTable {0} has {1} Error(s)!",
						myDataSet.Tables["Customers"].TableName,ErrDataRows.Length.ToString());

					// ... for each Row in the DataTable
					for (int i = 0; i <= ErrDataRows.Length -1; i++)
					{
						Console.WriteLine("Row Error for row {0} --  Error Msg={1}",
							ErrDataRows[i]["CustomerID"].ToString(),ErrDataRows[i].RowError);
					}
				}
				else
				{
					Console.WriteLine("=================");
					Console.WriteLine("DataTable {0} Has no errors",
						myDataSet.Tables["Customers"].TableName);
				}
			}
			catch(Exception e)
			{
				Console.WriteLine(e.ToString());
			}
		}
	}
}
